//1. Напишите функцию, которая возвращает массив, очищенный от пустых значений, не меняя исходный
var data = [0, '0', '', null, {}, [], [1, 2, 3]];

function clean(arr) {

  return arr.filter(function(el) {

    return (el == null)

      || (typeof el == 'number' || (typeof el == 'string' && el.length !== 0)) 
      || (el && typeof el === 'object' && Object.keys(el).length);

  });
}
console.log( clean(data) );



// 2. Напишите функцию-аналог splice,не используя никакие методы массива.
var arr1 = [1, 2, 4, 3];
    arr2 = [];
function splice(arr, index, deleteCount, ...elements) {

    for(var i = 0; i < arr.length; i++) { 

        if (arr.indexOf(arr[i]) < index || arr.indexOf(arr[i]) > index + deleteCount - 1) {
            arr2[arr2.length] = arr[i];
        }
    };
    if (elements.length !== 0) { 

        for(var i = 0; i < elements.length; i++) {
            arr2[i+index] = elements[i];
        }
    }
    
    return arr2;
};
console.log(splice(arr1, 2, 1)); // [4]
console.log(arr1); // [1, 2, 3]
splice(arr1, 2, 0, 100, 200, 300);
console.log(arr2); // [1, 2, 100, 200, 300, 3]



// 3. Напишите функцию, которая возвращает сумму всех чисел, переданных в качестве аргументов, число которых 
// не ограничено. Функция работает только с числами (включая строковые). Если какой-то из параметров -
//  массив, то к сумме добавляется также сумма значений этого массива (если какое-либо из значений этого
//   массива также является массивом, то к результату добавляется также и сумма его значений, и так далее).

// var sum = getSum(1, '1', 'one', [2, '2', 'two']);
// console.log( sum ); // 6
function getSum() {

    var arr = [].slice.apply(arguments);

    function sumRecursion(arr) {

        return arr.reduce(function (sum, elem) {

            if ( isNumber(elem) ) sum += +elem;
            else if ( Array.isArray(elem) ) sum += sumRecursion(elem);
            return sum;
        }, 0);

    }
    return sumRecursion(arr);
}
function isNumber(val) {
    return !isNaN(parseFloat(val)) && isFinite(val);
}
var sum = getSum(1, '1', 'one', [2, '2', 'two']);
console.log( sum );



// 4. Напишите функцию, которая рисует в указанном HTML-контейнере диаграмму из данных, представляющих из себя массив объектов:  каждый объект имеет свойства color и value, означающих соответственно  цвет столбца и его высоту.
function diagram(arr, id) {

    var canvas = document.getElementById(id),
        ctx = canvas.getContext("2d"),

        h = canvas.clientHeight,
        w = 60;

    for(var i = 0; i < arr.length; i++) {

        ctx.fillStyle = arr[i].color;
        ctx.fillRect(i*w, h - arr[i].value, w, arr[i].value);
    }
    
};
var target = [ {color: '#DE9797', value: 70}, {color: '#26d86733', value: 50}, {color: '#dc1fba33', value: 30}, {color: '#12146933', value: 70}, {color: '#13d6d833', value: 80}, {color: '#c3d63733', value: 90},];
diagram(target, 'diagram');

var target2 = [ {color: '#DE9797', value: 70}, {color: '#26d86733', value: 50}, {color: '#dc1fba33', value: 30}, {color: '#12146933', value: 70}, {color: '#13d6d833', value: 80}, {color: '#c3d63733', value: 90},];
diagram(target2, 'diagram2');


/*5. Напишите функцию, которая изображает в теге HTML картинку по данным, представляющим из себя двумерный массив закрашенных точек.
var points = [
    [3, 4, 5],
    [2, 3, 9, 16],
    [1, 2, 9, 10, 15, 16],
    ...
];*/
var points = [
    [3, 4, 5],
    [2, 3, 9, 16],
    [1, 2, 9, 10, 15, 16],
    [1, 2, 5, 6, 9, 10, 11, 12, 13, 14, 15, 16],
    [1, 2, 4, 5, 6, 7, 9, 12, 13, 16],
    [1, 2, 3, 4, 5, 6, 7, 8, 9, 12, 13, 16],
    [2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 14, 15, 16],
    [2, 3, 4, 5, 6, 7, 8, 10, 11, 12, 13, 14, 15],
    [2, 3, 4, 7, 8, 12, 13],
    [2, 3, 7, 8],
    [2, 3, 4, 5, 7, 8, 9, 10],
    [2, 3, 4, 5, 7, 8, 9, 10],
];
var buildTable = function () {

    let myTable = $('<table>').attr('id', 'myTable').css({  
        'border-spacing' : '0 0',
        'border-collapse' : 'collapse',
    }).appendTo('#table');

    for (i = 1; i <= 12; i++) {

        let tr = $('<tr>').appendTo(myTable);

        for (j = 1; j <= 16; j++) {

            $('<td>').css({
                'height' : '20px',
                'width' : '20px',
                'background-color' : '#eee',
                'border' : '1px solid #000' 
            }).appendTo(tr);
        }
    }
    for (i = 0; i < points.length; i++) {

        for (j = 0; j < points[i].length; j++) {

            $(`#myTable tr:nth-child(${i+1}) td:nth-child(${points[i][j]})`).css('background-color', '#000');
        }
    }   
}
buildTable();